
//xsetaseta@gmail.com
//
//Lector de sensor de temperatura externa Modelo prinstON
//29/09/2018


#include <avr/io.h>
#include <avr/interrupt.h>

#define IN_READ 2

unsigned long time,timeU,timeInicio,diferencia;
bool inicio;
int dato;
bool estadoDato;

int canal;
int grados;
int humedad;
int control;

unsigned long DatoSalida;
unsigned char DatoSalida1;

char Stemporal[100];

char NumBit;

void setup(void)
{
  Serial.begin(9600);
  Serial.println("Int433T2");
  pinMode(2, INPUT);
  pinMode(IN_READ, INPUT);

  cli();                // Disable INT
  EIMSK |= (1 << INT0);  // Enable external interrupt INT0
  EICRA |= (1 << ISC01); // Trigger INT0 on Change  en bajada
  sei();
}


void loop(void)
{
  if(estadoDato==1)
   {
     
     estadoDato=0;
     if(dato==255)
       { 
        DatoSalida1=0;
        DatoSalida=0;         
         goto salto2;
       }     
    if(dato==3) 
      {
  
        canal=(DatoSalida & 0x300000) >>20 ;
        grados=(DatoSalida >> 8) & 0xFFF ;
         if(grados & 2048) //negativos
           {
             grados =0x0FFF-grados;  
             grados *=-1;
           }
        humedad=DatoSalida&0x00FF;
        control=(DatoSalida & 0xffc00000) >>22 ;
       
       sprintf(Stemporal,"Canal,%02d,Grados,%05d,Humedad,%03d,Control,%d03,\n",canal,grados,humedad,control);        
       Serial.print(Stemporal);
       goto salto2; 
      }
    if(DatoSalida & 32768) DatoSalida1 |=1;
    DatoSalida1<<=1;
    DatoSalida<<=1;
    if(dato==1) DatoSalida|=1;
    
   }
   
salto2:
    ;
}


ISR(INT0_vect)
{
  time=micros();         
  diferencia=time-timeU;
  if (diferencia>2300 && diferencia<9900)
  {          
    if(diferencia>2390 && diferencia<2500)  //0
    {
      estadoDato=1;   dato=0;
      goto salto;
    }
    if(diferencia>4300 && diferencia<5050)  //1
    {             
      estadoDato=1;   dato=1;
      goto salto;
    }
    if(diferencia>9700 && diferencia<9900)  //empieza
    {
      estadoDato=1;   dato=3;
      goto salto;
    }
  }
  else
  {
    estadoDato=1; 
    dato=255; 
  }

salto: 
  timeU=time; 
}


