/***************************************************************
 * Name:      .cpp
 * Purpose:   Code for Application Frame
 * Author:    seta43 ()
 * Created:   2018-05-20
 * Copyright: seta43 ()
 * Versión 2
 **************************************************************/

#include "main.h"
#include "define.h"
#include "port.h"

char VARI[100];
int  ContadorI=0;
char Binput[100];
char Binput2[20];
int tiempo2=10,tiempo1=5;

int canal,grados,humedad,control,veces,ultimo;

unsigned char portok=0;



#define  ID_TEXTCTRL1   1001
#define  ID_STATICTEXT6   1002
#define  ID_TEXTCTRL11   1003
#define  ID_TEXTCTRL2   1004
#define  ID_STATICTEXT2   1005
#define  ID_TEXTCTRL3   1006
#define  ID_TEXTCTRL6   1007
#define  ID_TEXTCTRL9   1008
#define  ID_TEXTCTRL10   1009
#define  ID_STATICTEXT5   1010
#define  ID_COMBOBOX1   1011
#define  ID_TIMER1   1012


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(wxsensorT2Frame,wxFrame)
 
END_EVENT_TABLE();


wxsensorT2Frame::wxsensorT2Frame(wxWindow* parent,wxWindowID id)
{
   Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(274,352));
    
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, _("humedad"), wxPoint(160,192), wxDefaultSize, wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    wxFont TextCtrl1Font(12,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl1->SetFont(TextCtrl1Font); 
    
    StaticText6 = new wxStaticText(this, ID_STATICTEXT6, _("Sensor de temperatura\nModelo prinston\n433 MHz"), wxPoint(24,8), wxDefaultSize, wxALIGN_CENTRE, _T("ID_STATICTEXT6"));
    wxFont StaticText6Font(14,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText6->SetFont(StaticText6Font);
    
    TextCtrl11 = new wxTextCtrl(this, ID_TEXTCTRL11, _("Text"), wxPoint(152,88), wxSize(98,24), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL11"));
    TextCtrl11->SetForegroundColour(wxColour(27,48,103));
    wxFont TextCtrl11Font(13,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl11->SetFont(TextCtrl11Font);
    TextCtrl2 = new wxTextCtrl(this, ID_TEXTCTRL2, _("Text"), wxPoint(16,88), wxSize(128,22), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    TextCtrl2->SetForegroundColour(wxColour(76,5,5));
    wxFont TextCtrl2Font(13,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl2->SetFont(TextCtrl2Font);
   
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Canal"), wxPoint(32,160), wxSize(80,18), 0, _T("ID_STATICTEXT2"));
    wxFont StaticText2Font(12,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText2->SetFont(StaticText2Font);

   TextCtrl3 = new wxTextCtrl(this, ID_TEXTCTRL3, _("--"), wxPoint(120,152), wxSize(136,24), wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    wxFont TextCtrl3Font(16,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl3->SetFont(TextCtrl3Font);
    
    TextCtrl6 = new wxTextCtrl(this, ID_TEXTCTRL6, _("time"), wxPoint(160,224), wxDefaultSize, wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL6"));
    wxFont TextCtrl6Font(12,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl6->SetFont(TextCtrl6Font);
    
    TextCtrl9 = new wxTextCtrl(this, ID_TEXTCTRL9, _("--"), wxPoint(136,272), wxSize(128,22), 0, wxDefaultValidator, _T("ID_TEXTCTRL9"));
    wxFont TextCtrl9Font(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl9->SetFont(TextCtrl9Font);
    TextCtrl10 = new wxTextCtrl(this, ID_TEXTCTRL10, _("--"), wxPoint(8,312), wxSize(256,22), 0, wxDefaultValidator, _T("ID_TEXTCTRL10"));
    wxFont TextCtrl10Font(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    TextCtrl10->SetFont(TextCtrl10Font);
    StaticText5 = new wxStaticText(this, ID_STATICTEXT5, _("http://seta43.hol.es/electro.html\nhttp://seta43.blogspot.com.es/"), wxPoint(64,120), wxDefaultSize, 0, _T("ID_STATICTEXT5"));
   // StaticText5->SetForegroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_HIGHLIGHT));
    wxFont StaticText5Font(7,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText5->SetFont(StaticText5Font);
    
    #if YesWindows
    wxString __wxSingleChoiceDialogChoices_1[9] =
    {
        _("Select Serial"),_("com1"),_("com2"),_("com3"),_("com4"),_("com5"),_("com6"),_("com7"),_("com8")
    };
#else
    wxString __wxSingleChoiceDialogChoices_1[9] =
    {
        _("Select Serial"),_("/dev/ttyUSB0"), _("/dev/ttyUSB1"),  _("/dev/ttyUSB2"), _("/dev/ttyACM0"), _("/dev/ttyACM1"), _("/dev/ttyACM2"), _("/dev/ttyS0"), _("/dev/ttyS1")
    };
#endif
    ComboBox1 = new wxComboBox(this, ID_COMBOBOX1, wxT(""), wxPoint(8,272), wxSize(123,27), 6, __wxSingleChoiceDialogChoices_1, wxCB_DROPDOWN);
    ComboBox1->SetSelection(0);
    
     
    
    Timer1.SetOwner(this, ID_TIMER1);
    Timer1.Start(50, false);
    //*)
	
	 Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&wxsensorT2Frame::OnTimer1Trigger);	
	 Connect(ID_COMBOBOX1,wxEVT_COMMAND_COMBOBOX_SELECTED,(wxObjectEventFunction)&wxsensorT2Frame::OnComboBox1Selected);

}



void wxsensorT2Frame::AnalizarVer(void)
{
    wxString  Wgrados, Whora, Whumedad, Wcanal;
    int decimales;

    canal=atoi(VARI+6);
    grados=atoi(VARI+16);
    humedad=atoi(VARI+30);
    control=atoi(VARI+42);
    
   
    
    decimales=grados%10;
    if(decimales<0)decimales*=-1;
    
#if DEBUG
    printf("Canal=%d    ",canal);
    printf("Grados=%d.%d ",grados/10,decimales);
    printf("Humedad=%d   ",humedad);
    printf("Control=%d    \n",control);
#endif
   
    sprintf(Binput2,"Canal %d",canal);
    Wcanal= wxString::FromUTF8(Binput2);
   
    sprintf(Binput2,"%d.%d ºC",grados/10,decimales);
    Wgrados= wxString::FromUTF8(Binput2);
    
    sprintf(Binput2,"%d%%",humedad);
    Whumedad= wxString::FromUTF8(Binput2);

    wxDateTime now = wxDateTime::Now();
    sprintf(VARI,"%02d:%02d:%02d",now.GetHour(), now.GetMinute(), now.GetSecond());
    Whora= wxString::FromUTF8(VARI);
	
	if(grados==ultimo)veces++;
	
	if((control&3)==3 && veces>2)
		{
		StaticText2->SetLabel(Wcanal);
        TextCtrl6->SetValue(Whora);
        TextCtrl3->SetValue(Wgrados);
        TextCtrl1->SetValue(Whumedad);
		}
	 ultimo=grados;
}




void wxsensorT2Frame::OnComboBox1Selected(wxCommandEvent& event)
{
	   wxString msg,string1;
#if DEBUG     
    if(DEBUG) printf("Init\n");
#endif
#if YesWindows
    if(hSerial)CloseRs232();
#else
    if(fdrs232)CloseRs232();
#endif

    msg=ComboBox1->GetStringSelection();
    strcpy( VARI, (const char*)msg.mb_str(wxConvUTF8) );
    MODEMDEVICE=VARI;

    if(0!=IniRs232())
    {
        printf("NO %s\n",MODEMDEVICE);
        msg.Printf(wxT("No existe puerto"));
        wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
        msg.Printf(wxT("No port"));
        TextCtrl9->SetValue(msg);
        portok=0;
    }
    else
    {
        wxString string1(VARI, wxConvUTF8);
        TextCtrl9->SetValue(msg+_(" :9600,8,N,1"));      
		printf("SI %s\n",MODEMDEVICE);		    
        portok=1;
    }
}



wxsensorT2Frame::~wxsensorT2Frame()
{
    //(*Destroy(wxsensorT2Frame)
    //*)
}

void wxsensorT2Frame::OnTimer1Trigger(wxTimerEvent& event)
{
	int z;
    int nbytes;
    wxString StringTmp;

    tiempo1--;
    tiempo2--;

// cada 0,5 segundos
    if(portok==1 && tiempo2<0)
    {
    tiempo2=10;

#if YesWindows
        while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
        while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
        {
            //printf("Leer %d -> %s\n",ContadorI,Binput2);
            Binput[ContadorI]=Binput2[0];
            ContadorI++;
            if (Binput2[0] == '\n')
            {
                if(ContadorI<2)ContadorI=2;
                Binput[ContadorI-2]=0;
                ContadorI=0;
#if DEBUG
                printf("Leidos->%s\n",Binput);
#endif
                sprintf(VARI,"%s",Binput);
                wxString StringTmp(VARI, wxConvUTF8);
                TextCtrl10->SetValue(StringTmp);

                for(z=0; z<99; z++) if(VARI[z]==',')  VARI[z]=0;
                if(0==strncmp(VARI,"Canal",5))	 this->AnalizarVer();
            }
        }
    }

// cada 1 segundos ____________________________________________
    if(tiempo1<0)
    {
		veces=0;
        tiempo1=20;
        wxString StringTmp;
        wxDateTime now = wxDateTime::Now();

        sprintf(VARI,"%02d/%02d/%02d",now.GetDay(), now.GetMonth(), now.GetYear());
//		printf("%s  ",VARI);
        StringTmp= wxString::FromUTF8(VARI);
        TextCtrl2->SetValue(StringTmp);

        sprintf(VARI,"%02d:%02d:%02d",now.GetHour(), now.GetMinute(), now.GetSecond());
//		printf("%s  \n",VARI);
        StringTmp= wxString::FromUTF8(VARI);
        TextCtrl11->SetValue(StringTmp);

#if DEBUG
        printf("1S  portok=%d\n",portok);
        const char* cadena = StringTmp.mb_str();
        printf("%s\n",cadena);
#endif
    }

	
}



